import { world } from "@minecraft/server";

world.afterEvents.entityHurt.subscribe((event) => {
    const hurtEntity = event.hurtEntity;
    
    if (!hurtEntity || !hurtEntity.getComponent("minecraft:type_family").hasTypeFamily("horse")) return;
    const horseArmor = hurtEntity.getComponent("inventory").container.getSlot(1); 

    let damageReduction = 0;

    if (horseArmor) {
        if (horseArmor.typeId === "bv_e:iron_horse_armor") {
            damageReduction = 0.8; // 80% damage reduction for Iron Horse Armor
        } else if (horseArmor.typeId === "bv_e:gold_horse_armor") {
            damageReduction = 0.6; // 60% damage reduction for Golden Horse Armor
        } else if (horseArmor.typeId === "bv_e:diamond_horse_armor") {
            damageReduction = 0.96; // 96% damage reduction for Diamond Horse Armor
        }
    }
    if (damageReduction > 0) {
        const originalDamage = event.damage;
        const reducedDamage = originalDamage * (1 - damageReduction);
        event.cancel = true;
        if (event.cancel){
            hurtEntity.runCommand(`say Damage apply is cancel`)
        }
        hurtEntity.applyDamage(reducedDamage);
        hurtEntity.runCommand(`say Damage apply is ${reducedDamage}`)
    }
});
